﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Reflection;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            Assembly assembly = System.Reflection.Assembly.GetExecutingAssembly();
            Type type = assembly.GetType("Dictionary.Class.S0002.StudentDict");     //命名空间名 + 类名
            object obj = Activator.CreateInstance(type, true);

            try
            {
                FieldInfo classField = type.GetField("ClassName");
                Console.WriteLine("班级名称：" + classField.GetValue(obj).ToString());
            }
            catch (Exception ex)
            {
                Console.WriteLine("\t班级名称获取失败：" + ex.Message);
            }

            try
            {
                PropertyInfo TeaNameProperty = type.GetProperty("TeacherName");
                Console.WriteLine("\t教师姓名：" + TeaNameProperty.GetValue(obj, null).ToString());
            }
            catch (Exception ex)
            {
                Console.WriteLine("\t教师姓名获取失败：" + ex.Message);
            }

            foreach (FieldInfo field in type.GetFields())
            {
                try
                {
                    if (field.Name == "AttributeDict")
                    {
                        Dictionary<string, string> dict = field.GetValue(obj) as Dictionary<string, string>;

                        foreach (string key in dict.Keys)
                        {
                            Console.WriteLine("\t\t学号：{0} -> 姓名：{1}", key, dict[key]);
                        }
                    }
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.Message.ToString());
                }
            }

            MethodInfo method = type.GetMethod("GetStuNameByCode");
            string strStuName = (string)method.Invoke(obj, new string[] { "02" });
            Console.WriteLine("\t\t学号【{0}】 的学生姓名为：{1}","02",strStuName);

            Console.ReadLine();
        }
    }
}
